#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <conio.h>
#include "../include/utilities.h"
#include "../include/patcher.h"

void checkFiles();
int menu0();
int menu1();
void clead_outfit_options_menu();
void bern_options_menu();
void customization_menu();
void cavaro_options_menu(PatcherState* patcherState);


int main()
{
    int menu0ChosenOption = -1;

    checkFiles();

    while (1)
    {
        menu0ChosenOption = menu0();

        if (menu0ChosenOption == EXIT)
        {
            break;
        }
        else if (menu0ChosenOption == INSTALL)
        {
            runPatcher();
        }
        else if (menu0ChosenOption == 2)
        {
            customization_menu();
        }
        else if (menu0ChosenOption == 3)
        {
            undoLastChanges();

        }
        else if (menu0ChosenOption == 4)
        {
           backupMenu();
        }
    }
    return 0;
}


int menu0()
{
    MenuElements menu;
    menu.nOptions = 3;
    strcpy(menu.header,"What do you want to do?");
    strcpy(menu.menuoptions[1],"Install");
    strcpy(menu.menuoptions[2],"Customize");
    strcpy(menu.menuoptions[3],"Undo last changes");
    strcpy(menu.menuoptions[4],"Restore Backup");
    strcpy(menu.menuoptions[0],"Exit");

    return createMenu(menu);
}


void customization_menu()
{
    PatcherState* patcherState = loadPatcherState(PATCHER_STATE_FILE_NAME);

    char input  = '\0';
    int int_input = 0;
    while(1)
    {
        system("cls");
        printMainHeader();
        printf("\n1. Clead Oufit ");(patcherState->booleanValues[CLEAD]? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n2. Cavaro      ");(patcherState->booleanValues[CAVARO]? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n3. Eckett      ");(patcherState->booleanValues[ECKETT]? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n4. Cartian     ");(patcherState->booleanValues[CARTIAN]? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n5. Pappilo     ");(patcherState->booleanValues[PAPPILO]? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n6. Bern        ");(patcherState->booleanValues[BERN]? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n");
        printf("\n[F1] - Customize Clead");
        printf("\n[F2] - Customize Bern");
        printf("\n[F3] - Customize Cavaro");
        printf("\n");
        printf("\nENTER - Confirm");
        printf("\nESC   - Go Back\n");

        input = getch();

        int_input = input - '0';

        if (int_input >= 1 && int_input <= 6)
        {
            patcherState->booleanValues[int_input-1] = !patcherState->booleanValues[int_input-1];
        }
        else if (input == F1)
        {
            clead_outfit_options_menu(patcherState);
        }
        else if (input == F2)
        {
            bern_options_menu(patcherState);
        }
         else if (input == F3)
        {
            cavaro_options_menu(patcherState);
        }
        else if (input == ESC || input == ENTER)
        {
            if (input == ENTER)
            {
               savePatcherState(PATCHER_STATE_FILE_NAME,patcherState);
            }

            free(patcherState);

            break;
        }
    }
}

void clead_outfit_options_menu(PatcherState* patcherState)
{
    char input = '\0';
    int inputInt = 1;

    while(1)
    {
        system("cls");
        printf("\n\nClead Outfit Lowerbody Options:\n");
        printf("\n1 - Bern Shorts"); if (patcherState->cleadOption == 0) { printf(" <--");}
        printf("\n2 - Default pants"); if (patcherState->cleadOption == 1) { printf(" <--");}
        printf("\n3 - None");  if (patcherState->cleadOption == 2) { printf(" <--");}
        printf("\n4 - Bern belt only"); if (patcherState->cleadOption == 3) { printf(" <--");}
        printf("\n\nARROWS - Change selected option");
        printf("\nENTER  - Confirm");
        printf("\nESC    - Go Back ");
        input = getch();

        inputInt = input - 48;

        if (input == ENTER || input == ESC)
        {
            break;
        }
        else if(input >= '1' && input <= '4')
        {
            patcherState->cleadOption = inputInt - 1;

        }
        else if(input == ARROW_UP)
        {
            if (patcherState->cleadOption > 0)
            {
                patcherState->cleadOption--;
            }
            else
            {
                patcherState->cleadOption = 3;
            }
        }
        else if(input == ARROW_DOWN)
        {
            if (patcherState->cleadOption < 3)
            {
                patcherState->cleadOption++;
            }
            else
            {
                patcherState->cleadOption = 0;
            }
        }
    }
}

void bern_options_menu(PatcherState* patcherState)
{
    char input  = '\0';
    int int_input = 0;
    while(1)
    {
        system("cls");
        printMainHeader();
        printf("\n1. Belt only                  ");(patcherState->bernOptions[0]? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n2. Remove chest silver plate  ");(patcherState->bernOptions[1]? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n");
        printf("\nENTER - Confirm");
        printf("\nESC   - Go Back\n");

        input = getch();

        int_input = input - '0';

        if (int_input >= 1 && int_input <= 2)
        {
            patcherState->bernOptions[int_input-1] = !patcherState->bernOptions[int_input-1];
        }
        else if (input == ESC || input == ENTER)
        {
            break;
        }
    }
}


void cavaro_options_menu(PatcherState* patcherState)
{
    char input  = '\0';
    int int_input = 0;
    while(1)
    {
        system("cls");
        printMainHeader();
        printf("\n1. Cavaro Panties  ");(patcherState->cavaroOption? printColor("On",GREEN) : printColor("Off", RED));
        printf("\n");
        printf("\nENTER - Confirm");
        printf("\nESC   - Go Back\n");

        input = getch();

        int_input = input - '0';

        if (int_input == 1)
        {
            patcherState->cavaroOption = !patcherState->cavaroOption;
        }
        else if (input == ESC || input == ENTER)
        {
            break;
        }
    }
}

void checkFiles()
{
    if (!fileExists("pad00000.meta"))
    {
        printf("\nError: could not locate pad00000.meta\n\n");
        printf("\nMake sure you have extracted the program in your PAZ folder\n\n");
        system("PAUSE");
    }
}

