#include "../include/patcher.h"


void changeNeedPatch(FileBlock* fileToPatch, char** filesRequired)
{
int j = 0;
   for(j = 0; j < 4; j++)
   {
       if (strcmpi(fileToPatch->fileName,filesRequired[j]) == 0)
       {
           fileToPatch->needPatch = 1;
       }
   }
}


/* **********************************************************************
 *
 *                        RUN PATCHER
 *
 ************************************************************************/
void runPatcher()
{
    FileBlock* fileBlocks = NULL;
    FileBlock* filesToPatch = NULL;
    long filesToPatchCount = 0;
    MetaFileInfo* metaFileInfo = NULL;
    int filesNotPatchedCount = 0;
    int filesSkippedCount = 0;



    PatcherState* patcherState = loadPatcherState(PATCHER_STATE_FILE_NAME);

    int i = 0, j = 0;

     printf("\nCounting files...\n\n");
    // Counts how many files there is in the "files_to_patch" folder assigns to filesToPatchCount,
    // and get all the file names in folders and sub folders and returns them as an array of strings
    filesToPatch = getAllFiles("files_to_patch_bmir\\","*",&filesToPatchCount);

    printf("%ld files were found in files_to_patch_bmir\\\n\n", filesToPatchCount);


    if (!backupExists())
    {
        createBackup();
    }

    metaFileInfo = getMetaFileInfo(getLatestBackup());
    fileBlocks = fillFileBlocks(metaFileInfo);



    /* for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        printf("%ld|%ld|%ld|%ld|%s|%s\n",fileBlocks[i].hash,fileBlocks[i].folderNum,fileBlocks[i].fileNum,fileBlocks[i].pazNum,fileBlocks[i].folderName,fileBlocks[i].fileName);
    }*/


        if (patcherState->cleadOption == BERN_SHORTS || patcherState->cleadOption == CLEAD_BELT_ONLY)
        {
            // Bern Shorts model as Clead Pants
             printf("Copy \"clead_lowerbody\\bern\\phw_00_lb_0004.pac\"");
            systemCopy("phw_00_lb_0004.pac","patcher_resources\\models\\clead_lowerbody\\bern\\","files_to_patch_bmir\\");
        }
        if (patcherState->cleadOption == NONE)
        {
             printf("Copy \"clead_lowerbody\\none\\phw_00_lb_0004.pac\"");
            systemCopy("phw_00_lb_0004.pac","patcher_resources\\models\\clead_lowerbody\\none\\","files_to_patch_bmir\\");
        }
        if (patcherState->cleadOption == DEFAULT_PANTS)
        {
            printf("Copy \"clead_lowerbody\\default\\\"" );
            systemCopy("phw_00_lb_0004.pac","patcher_resources\\models\\clead_lowerbody\\default\\","files_to_patch_bmir\\");
        }

        if (patcherState->cleadOption == BERN_SHORTS && patcherState->bernOptions[BELT_ONLY] != ON)
        {
            // Bern shorts red texture
            printf("Copy \"bern_shorts\\red\\phw_01_lb_0003.dds\"");
             systemCopy("phw_01_lb_0003.dds","patcher_resources\\textures\\bern_shorts\\red\\","files_to_patch_bmir\\");
        }
        if (patcherState->cleadOption == CLEAD_BELT_ONLY || patcherState->bernOptions[BELT_ONLY] == ON)
        {
             // Bern shorts belt only texture
              printf("Copy \"bern_shorts\\belt_only\\phw_01_lb_0003.dds\"");
             systemCopy("phw_01_lb_0003.dds","patcher_resources\\textures\\bern_shorts\\belt_only\\","files_to_patch_bmir\\");
        }



    printf("\nMarking files to patch...\n");
    char *filesRequired[][4] =
    {

/*CLEAD*/  {"phw_00_lb_0004.pac","phw_00_ub_0011.dds","phw_00_ub_0004.dds"},

/*CLEAD + BERN SHORTS*/     {"phw_01_lb_0003.dds","",""},
/*CLEAD + LOWERED PANTS*/   {"phw_00_lb_0004.dds","phw_00_lb_0004_dec.dds",""},
/*CLEAD + NONE*/            {"phw_00_lb_0004.pac","common_decals_road_04_dec.dds",""},
/*CLEAD + BERN BELT*/       {"phw_01_lb_0003.dds","",""},


/*CAVARO*/      {"phw_00_ub_0030_hair.dds","phw_00_eca_0030.dds","phw_00_ub_0030.pac","common_decals_road_04_dec.dds"},
/*ECKETT*/      {"phw_01_sho_0002_dec.dds","",""},
/*CARTIAN*/     {"phw_00_ub_0043.dds","phw_00_ub_0043_hair.dds","phw_00_cloak_0043_hair.dds"},
/*PAPPILO*/     {"phw_00_ub_0063.dds","",""},

/*BERN + BELT_ONLY*/     {"phw_01_lb_0003.dds","","",},
/*BERN - SILVER PLATE*/     {"phw_01_sho_0003.dds","",""},
/*CAVARO PANTS*/     {"phw_00_lb_0030.pac","common_decals_road_04_dec.dds",""}
    };

    for (i = 0; i < filesToPatchCount; i++)
    {
        if (patcherState->booleanValues[CLEAD] == ON)
        {
            changeNeedPatch(&filesToPatch[i], filesRequired[0]);

            if (patcherState->cleadOption == BERN_SHORTS)
            {
                changeNeedPatch(&filesToPatch[i], filesRequired[1]);
            }
            else if (patcherState->cleadOption == DEFAULT_PANTS)
            {
                changeNeedPatch(&filesToPatch[i], filesRequired[2]);
            }
            else if (patcherState->cleadOption == NONE)
            {
                changeNeedPatch(&filesToPatch[i], filesRequired[3]);
            }
            else if (patcherState->cleadOption == CLEAD_BELT_ONLY)
            {
                changeNeedPatch(&filesToPatch[i], filesRequired[4]);
            }
        }
        if (patcherState->booleanValues[CAVARO] == ON)
        {
             changeNeedPatch(&filesToPatch[i], filesRequired[5]);

             if (patcherState->cavaroOption != ON)
             {
                 changeNeedPatch(&filesToPatch[i], filesRequired[11]);
             }
        }
        if (patcherState->booleanValues[ECKETT] == ON)
        {
            changeNeedPatch(&filesToPatch[i], filesRequired[6]);
        }
        if (patcherState->booleanValues[CARTIAN] == ON)
        {
            changeNeedPatch(&filesToPatch[i], filesRequired[7]);
        }
        if (patcherState->booleanValues[PAPPILO] == ON)
        {
            changeNeedPatch(&filesToPatch[i], filesRequired[8]);
        }
        if (patcherState->booleanValues[BERN] == ON)
        {
            if (patcherState->bernOptions[BELT_ONLY] == ON)
            {
                changeNeedPatch(&filesToPatch[i], filesRequired[9]);
            }

            if (patcherState->bernOptions[REMOVE_SILVER_CHEST] == ON)
            {
                changeNeedPatch(&filesToPatch[i], filesRequired[10]);
            }
        }
    }


    qsort(filesToPatch,filesToPatchCount,sizeof(FileBlock),compare);
    int filesNeedingPatch = 0;
    for (i = 0; i < filesToPatchCount; i++)
    {

        if (filesToPatch[i].needPatch)
        {
            printColor("Patch ", GREEN);
            filesNeedingPatch++;
        }
        else
        {
            printf("      ");
        }
        printf("%s  \n", filesToPatch[i].fileName);
    }
    printf("\n(%d/%ld) files will be patched\n",filesNeedingPatch, filesToPatchCount);
    ///PAUSE();


    /// SEARCH FILE BLOCKS
    printf("\nSearching for files in the meta file...\n");

    FileBlock* fileBlockFound = NULL;

    for (j = 0; j < filesToPatchCount; j++)
    {

        printf("\n(%d/%ld): %s ",j + 1, filesToPatchCount, filesToPatch[j].fileName);

        if ((strcmpi(filesToPatch[j].fileName,"multiplemodeldesc.xml") == 0) ||(strcmpi(filesToPatch[j].fileName,"partcombinationdesc.xml") == 0))
        {
             printColor("Skipped", YELLOW);
             filesToPatch[j].needPatch = -2;
             filesSkippedCount++;
        }
        else
        {
            // Searches all the File Blocks for the file name
            fileBlockFound = NULL;


            for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
            {
               if (strcmpi(fileBlocks[i].fileName,filesToPatch[j].fileName) == 0)
                {
                    fileBlockFound = &fileBlocks[i];
                }
            }

            if (fileBlockFound != NULL) // If the name was found
            {
                addToFilesToPatch(fileBlockFound, &filesToPatch[j]);
                printColor("Found!", GREEN);
            }
            else
            {
                printColor("Not Found.", RED);
                filesNotPatchedCount++;
            }
        }
    }

        /// COPYING FILES
     printf("\n\nCopying files from \"files_to_patch\\\" to their right locations..  .\n");
     copyFilesBack(filesToPatch, filesToPatchCount);



    /// PATCHING META FILE
    patchMetaFile(filesToPatch, filesToPatchCount);

    generatePartcutdesc(fileBlocks,metaFileInfo);

      printf("\n\nFinished!\n\n");

    if(filesNotPatchedCount > 0)
    {
        printColor("Those files could not be found in your pad00000.meta file:", RED);
        int lineCount = 0;
        for(i = 0; i < filesToPatchCount; i++)
        {
            if(filesToPatch[i].needPatch == 0)
            {
                if (lineCount % 4 == 0)
                {
                    printf("\n");

                }
                printf("%s\t",filesToPatch[i].fileName);
                lineCount++;
            }
        }
        printf("\n");
        printf("\n\nCheck \"Paz\\patcher_resources\\missing_files.txt\" to see if any of those files are in this list.\n");
        printf("If they are, there is nothing it can be done at the moment.");
    }



    printColor("\n\n-------------- Overall Results --------------\n", YELLOW);
    printf("             Success: \033[32;1m%ld\033[0m Fails: \033[31;1m%d\033[0m",filesToPatchCount - filesNotPatchedCount - filesSkippedCount, filesNotPatchedCount);


    if (filesNotPatchedCount == 0)
    {
        printColor("\n\n\tAll files have been patched successfully!", GREEN);
    }

    printf("\n\n");
    system("PAUSE");

    // END INSTALL
    for(i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        free(fileBlocks[i].fileName);
        free(fileBlocks[i].folderName);
    }

    free(fileBlocks);

    for(i = 0; i < filesToPatchCount; i++)
    {
        free(filesToPatch[i].fileName);
        free(filesToPatch[i].originalPath);
    }
    free(filesToPatch);
}


void patchMetaFile(FileBlock* filesToPatch, int filesToPatchCount)
{
    int i = 0;
    int filesPatched = 0;
    long random_folder_num = 1;
    long random_file_num = 60556;

    /*printf("\n\nWe are about to make changes to your pad00000.meta file.");
    printf("\nPlease make sure you have made a manual backup before proceeding...\n\n");

    system("PAUSE");*/

    printf("\n\nPatching Meta File...\n");

     /// QUICK SORT "Files to patch" according to the meta offset
    qsort(filesToPatch,filesToPatchCount,sizeof(FileBlock),compare_meta_offset);


    FILE* metaFile = openFile("pad00000.meta","rb+");
    createPath("patcher_resources\\");
    FILE* modFile = fopen(concatenate("patcher_resources\\",LATEST_MODIFICATIONS_FILE_NAME),"wb+");

     printf("                 HASH  FOLDER_NUM FILE_NUM   OFFSET| FILE_NAME\n");
    for (i = 0; i < filesToPatchCount; i++)
    {

        if(filesToPatch[i].needPatch == 1)
        {

            // Backup the original values to the  latest modification file
            fwrite(&filesToPatch[i].metaOffset,sizeof(long),1,modFile);
            fwrite(&filesToPatch[i].folderNum,sizeof(long),1,modFile);
            fwrite(&filesToPatch[i].fileNum,sizeof(long),1,modFile);

            fseek(metaFile,filesToPatch[i].metaOffset + sizeof(long), SEEK_SET); // Goes to the position right after the Hash, which has the folder num value

            /// The most important part, breaks the meta file index by changing the 2 next ints after the hash with any random value that doesn't have a folderNum && fileNum match
            fwrite(&random_folder_num, sizeof(long),1,metaFile);
            fwrite(&random_file_num, sizeof(long),1,metaFile);

            //Sleep(30);
            printColor("Patched  ", GREEN);

        }
        else
        {
            fseek(metaFile,filesToPatch[i].metaOffset + sizeof(long), SEEK_SET); // Goes to the position right after the Hash, which has the folder num value

            // Restore
            fwrite(&filesToPatch[i].folderNum, sizeof(long),1,metaFile);
            fwrite(&filesToPatch[i].fileNum, sizeof(long),1,metaFile);

            printColor("Restored ", YELLOW);
        }
        printf("%.3d - %s %s  %s %.8ld| %s\n",filesPatched + 1, endian_convert((int)filesToPatch[i].hash),endian_convert((int)filesToPatch[i].folderNum),endian_convert((int)filesToPatch[i].fileNum), filesToPatch[i].metaOffset, filesToPatch[i].fileName);


        filesPatched++;
    }


    fclose(metaFile);
    fclose(modFile);
}


void addToFilesToPatch(FileBlock* fileBlockFound, FileBlock* filesToPatch)
{
    filesToPatch->metaOffset = fileBlockFound->metaOffset;
    filesToPatch->hash = fileBlockFound->hash;
    filesToPatch->folderNum = fileBlockFound->folderNum;
    filesToPatch->fileNum = fileBlockFound->fileNum;
    filesToPatch->folderName = fileBlockFound->folderName;
    //filesToPatch->needPatch = 1;
}

void copyFilesBack(FileBlock* filesToPatch, int filesToPatchCount)
{
    int i = 0;
    /*int replaceAll = 0;
    int skippAll = 0;
    char input = '\0';*/
    char* root = bdoRootFolder();
    int copyed = 0;
    for(i = 0; i < filesToPatchCount; i++)
    {
        if(filesToPatch[i].needPatch == 1)
        {
            char* folderPath = concatenate(root,filesToPatch[i].folderName);
            //char* filePath = concatenate(folderPath,filesToPatch[i].fileName);
            createPath(folderPath);

            printf("%.2d - %s", copyed+1, filesToPatch[i].fileName);
            systemCopy(filesToPatch[i].fileName,filesToPatch[i].originalPath,folderPath);

            copyed++;

            /*if (fileExists(filePath))
            {
                if (replaceAll == 0 && skippAll == 0)
                {
                    input = '\0';
                    while (input != ENTER && input != BACKSPACE && input != 's' && input != 'S' && input != 'R' && input != 'r')
                    {
                        printf("\nThe file \"%s\" already exists in \"%s\"\n", filesToPatch[i].fileName,folderPath);
                        printf("ENTER = Replace    ESCAPE = Skip   R = Replace All   S = Skip All\n>");
                        input = getch();

                    }
                    if (input == 'r' || input == 'R')
                    {
                        replaceAll = 1;
                    }
                     if (input == 's' || input == 'S')
                    {
                        skippAll = 1;
                    }
                    if (input == ENTER || input == 'r' || input == 'R')
                    {
                        printf("(%d/%d) - %s", i+1, filesToPatchCount, filesToPatch[i].fileName);
                        systemCopy(filesToPatch[i].fileName,filesToPatch[i].originalPath,folderPath);
                    }
                }
                else if (skippAll == 0)
                {
                    printf("(%d/%d) - %s", i+1, filesToPatchCount, filesToPatch[i].fileName);
                    systemCopy(filesToPatch[i].fileName,filesToPatch[i].originalPath,folderPath);
                }
            }
            else
            {
                printf("(%d/%d) - %s", i+1, filesToPatchCount, filesToPatch[i].fileName);
                systemCopy(filesToPatch[i].fileName,filesToPatch[i].originalPath,folderPath);
            }*/
         }
    }
}





